local shader = love.graphics.newShader[[
extern vec2 centre;
vec4 effect(vec4 colour, Image texture, vec2 texture_coords, vec2 screen_coords)
{
  vec2 source = texture_coords - centre;
  number len = length(source);
  // Alter the length to obtain the effect
  len = pow(len, 0.5);
  // Find the source point to read from
  source = source * len + centre;
  // Return the final value
  return Texel(texture, source) * colour;
}

]]
shader:send('centre', {0.5, 0.5})

local image = love.graphics.newImage('image1.jpg')

local t = 0
function love.update(dt)
  t = t + dt
end

function love.draw()
  if t < 2 then
    love.graphics.setShader(shader)
  elseif t > 4 then
    t = 0
  end
  love.graphics.draw(image, 0, 0, 0, 1)
  love.graphics.setShader()
end

function love.keypressed(k)
  if k == "escape" then return love.event.quit() end
end
